/// <reference types="node" />
import { ExplicitContext } from 'zipkin';
import * as Transport from 'winston-transport';
import { TransformFunction } from 'logform';
import * as winston from 'winston';
export interface Levels {
    [key: string]: number;
}
export declare const DEFAULT_ID = "instance";
export declare const DEFAULT_LEVELS: Levels;
export declare const DEFAULT_LEVEL = "info";
export declare const logger: Logger;
export declare function use(id: any): winston.Logger;
export declare function createConsoleTransport(): Transport;
export declare function createFluentTransport({ id, host, port, requireAckResponse, security, timeout, tls, tlsOptions, }?: CreateFluentTransportParameters): Transport;
export declare function createZipkinContextFormatter({ loggerId, context, }: CreateZipkinContextFormatter): TransformFunction;
export declare type Initialize = (params?: InitializeParameters) => void;
export interface InitializeParameters {
    id?: string;
    formats?: TransformFunction[];
    setPrimary?: boolean;
    levels?: Levels;
    level?: string;
    transports?: Transport[];
    plugins?: Plugins[];
}
export interface Logger {
    count: number;
    initialize: Initialize;
    _instances: LoggerInstance;
    [key: string]: any;
}
export interface LoggerInstance {
    [key: string]: winston.Logger;
}
export interface Plugins {
    format?: TransformFunction;
    transport?: Transport;
}
export interface FluentLoggerTlsOptions {
    ca?: Buffer | string;
}
export interface FluentLoggerSecurity {
    clientHostname?: string;
    sharedKey?: string;
    username?: string;
    password?: string;
}
export interface CreateFluentTransportParameters {
    id?: string;
    host?: string;
    port?: number;
    timeout?: number;
    requireAckResponse?: boolean;
    security?: FluentLoggerSecurity;
    tls?: boolean;
    tlsOptions?: FluentLoggerTlsOptions;
}
export interface CreateZipkinContextFormatter {
    loggerId: string;
    context: ExtendedExplicitContext;
}
export interface RawExplicitContext {
    spanId: string;
    parentId: string;
    traceId: string;
    sampled: Symbol | boolean;
}
export interface ExtendedExplicitContext extends ExplicitContext {
    currentCtx: RawExplicitContext;
}
export interface CreateZipkinContextLoggerParameters extends InitializeParameters {
    context?: ExtendedExplicitContext | null;
}
