"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai = require("chai");
var sinon = require("sinon");
var sinonChai = require("sinon-chai");
var winston = require("winston");
var _1 = require("./");
chai.use(sinonChai);
var expect = chai.expect;
describe('@joeir/logger-application', function () {
    it('increases the count for every time init() is called', function () {
        var initialCount = _1.logger.count;
        _1.logger.initialize();
        expect(_1.logger.count).to.equal(initialCount + 1);
    });
    describe('.initialize()', function () {
        it('creates a logger instance with the specified instance', function () {
            var formatterSpy = sinon.spy();
            var format = function (info) {
                formatterSpy(info);
                return info;
            };
            var message = 'sss';
            var levels = { a: 1, b: 0 };
            var level = 'b';
            var transport = new winston.transports.Console();
            _1.logger.initialize({
                id: '_test',
                formats: [format],
                levels: levels,
                level: level,
                setPrimary: true,
                transports: [transport],
            });
            expect(_1.logger._instances._test).to.exist;
            expect(_1.logger._instances._test.levels).to.equal(levels);
            expect(_1.logger._instances._test.level).to.equal(level);
            _1.logger.a(message);
            expect(formatterSpy).to.be.calledOnce;
            expect(formatterSpy).to.be.calledWith(sinon.match(function (v) { return v.message === message; }));
        });
    });
});
//# sourceMappingURL=index.test.js.map